#include "I2CLCDDRV.h"

uint8 bl_stat=BLOFF;

/*
d7 d6 d5 d4 d3 d2 d1 d0
d7 d6 d5 d4 bl E  RW RS

I2c ݃[`
I2CAhX27h wb_Őݒ
f[^V[g̒ʂ 3oCg\ŃANZX
1:RS | RW |E=L | DATA
2:RS | RW |E=H | DATA
3:RS | RW |E=L | DATA

*/
uint16 LCD_Write(uint8 ch)
{
	uint16 status = TRANSFER_ERROR;
    uint8 buffer[PACKET_SIZE],ch1;
    ch1=ch | bl_stat;
	buffer[0]=ch1 & AEn;
    buffer[1]=ch1 | En;
    buffer[2]=ch1 & AEn;
    I2CM_MasterWriteBuf(I2C_LCD_ADDR, buffer, PACKET_SIZE, I2CM_MODE_COMPLETE_XFER);
	while (0u == (I2CM_MasterStatus() & I2CM_MSTAT_WR_CMPLT))
    {
        /* Waits until master completes write transfer */
    }
    /* Displays transfer status */
    if (0u == (I2CM_MSTAT_ERR_XFER & I2CM_MasterStatus()))
    {
        /* Check if all bytes was written */
        if(I2CM_MasterGetWriteBufSize() == BUFFER_SIZE)
        {
            status = TRANSFER_CMPLT;
			CyDelayUs(50);	
        }
    }
    else
    {
    }
    (void) I2CM_MasterClearStatus();
	return (status);
}
//obNCgݒ@LCDo͎Ɏgϐɐݒ@onoff=ON_BL onoff=OFF_BL
void LCD_BackLight(uint8 onoff)
{
    bl_stat=BLOFF;
    if(onoff!=OFF_BL)bl_stat=BLON;
}

//LCDNAR}h
void LCD_Clear()
{
    LCD_Write(LCD_CMD_CLEARDISPLAYH);
    LCD_Write(LCD_CMD_CLEARDISPLAY);
	CyDelay(20);
}
//LCD HOMER}h
void LCD_Home()
{
    LCD_Write(LCD_CMD_HOMEH);
    LCD_Write(LCD_CMD_HOME);
	CyDelay(20);	
}
//\ʒuݒ 20x4s
//2sł͂
void LCD_SetPos(uint8 x, uint8 y)
{
    uint8 ch,ch1;
    ch=x;
    switch(y)
    {
        case 1:
        ch=0x40+x;
        break;
        case 2:
        ch=20+x;
        break;
        case 3:
        ch=0x40+20+x;
        break;
    }    
    ch1=ch & LOW8MASK;
    LCD_Write(ch1 | BLON | LCD_SETDDRAMADDR );
    ch1=ch << 4;
    ch1=ch1 & LOW8MASK;
    LCD_Write(ch1 );
}
//o
void LCD_Puts(char8 *s)
{
uint8 ch;
    while(*s) {
        ch=*s & LOW8MASK;
        ch=ch | Rs; 
	    LCD_Write(ch);
        ch=*s << 4;
        ch=ch & LOW8MASK;
        ch=ch | Rs; 
	    LCD_Write(ch);
        s++;
	}
}
//LCD 
void LCD_Init()
{
    CyDelay(20);
    LCD_Write(LCD_CMD_INIT_FUNCTIONSET);
    CyDelay(5);
    LCD_Write(LCD_CMD_INIT_FUNCTIONSET);
    CyDelay(1);
    LCD_Write(LCD_CMD_INIT_FUNCTIONSET);
    LCD_Write(LCD_CMD_FUNCTIONSETH);
// function set 4bit duty:1/16,size:5*7 
    LCD_Write(LCD_CMD_FUNCTIONSETH);
    LCD_Write(LCD_CMD_FUNCTIONSET);
// display on,cursor off,blink off 
    LCD_Write(LCD_CMD_DISPLAYONH);
    LCD_Write(LCD_CMD_DISPLAYON);
//DISPLAY CLEAR
    LCD_Write(LCD_CMD_CLEARDISPLAYH);
    LCD_Write(LCD_CMD_CLEARDISPLAY);
        CyDelay(5);
// address:auto increment,cursor shift:right 
    LCD_Write(LCD_CMD_ENTRYH);
    LCD_Write(LCD_CMD_ENTRY);    
    LCD_BackLight(ON_BL);
    
}


/* [] END OF FILE */


